import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MovingAimCreator here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MovingAimCreator extends NoScrollObjects
{
    private int ObjectNumber=0;
    public int Time=0;
    public int TimeSteps=10;
    public int []Object;
    public int []X;
    public int []Y;
    public int []Z;
    public int []Steps;

    public MovingAimCreator(int []x,int []y,int []z,int []O,int T)
    {
        this(x,y,z,O,1,T,0);
    }

    public MovingAimCreator(int []x,int []y,int []z,int []O,double Speed,int T,int StartTime)
    {
        this(x,y,z,new int[z.length],O,T);
        Time=StartTime;
        for(int h=0; h<x.length-1;h++)
        {
            Steps[h]=(int)(Math.round(Math.round(Math.hypot(Pos(x[h+1]-x[h]),Pos(y[h+1]-y[h]))))*1/Speed);
        }
    }

    public MovingAimCreator(int []x,int []y,int []z,int []s,int []O,int T)
    {
        X=x;
        Y=y;
        Z=z;
        Steps=s;
        TimeSteps=T;
        Object=O;
        setImage(new GreenfootImage(1,1));
    }

    private double Pos(double a)
    {
        if(a<0)
            a=-a;
        return a;
    }

    public void act() 
    {
        if(Time>=TimeSteps)
        {
            ObjectNumber++;
            if(ObjectNumber>=Object.length)
                ObjectNumber=0;
            int a = Object[ObjectNumber];
            MovingAims MA;
            if(a==0)
                MA=new MovingTux(X,Y,Z,Steps);
            else
                MA=new MovingCamel(X,Y,Z,Steps);

            getWorld().addObject(MA,getX(),getY());
            MA.act();
            Time=0;
        }
        else
        {
            Time++;
        }
    }
}
