import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Aim here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class MovingAims extends Aims
{
    private int LastArr=0;
    private int []LocationY;
    private int []LocationX;
    private int []LocationZ;
    private int []Steps;
    private boolean Started=false;
    private double MoveY;
    private double MoveX;
    private double MoveZ;
    private double PosY;
    private double PosX;
    private double PosZ;
    private int Steped = 0;
    private int Shortest;
    public boolean Turner=true;

    public MovingAims(int []X, int []Y, int []Z, int []Steps)
    {
        LocationX=X;
        LocationY=Y;
        LocationZ=Z;
        this.Steps=Steps;
        int h = X.length;
        if(Y.length<h)
            h=Y.length;
        if(Z.length<h)
            h=Z.length;
        if(Steps.length+1<h)
            h=Steps.length+1;
        Shortest=h;
    }

    public void act() 
    {
        move();
        super.act();
    }    

    public void move()
    {
        if(!Started)
        {
            setLocation(LocationX[LastArr],LocationY[LastArr],LocationZ[LastArr]);
            PosY=getY();
            PosX=getX();
            PosZ=getZ();
            LastArr++;
            while(Steps[LastArr-1]<=0)
                Steps[LastArr-1]++;
            MoveX  =  (double)(LocationX[LastArr]-getX())/(double)(Steps[LastArr-1]);
            MoveY  =  (double)(LocationY[LastArr]-getY())/(double)(Steps[LastArr-1]);
            MoveZ  =  (double)(LocationZ[LastArr]-getZ())/(double)(Steps[LastArr-1]);
            if(Turner)
                turnTo(LocationX[LastArr],LocationY[LastArr]);
            Steped =  0;
            Started=  true;
        }

        if(Steped >= Steps[LastArr-1])
        {
            if(LastArr>=Shortest-1)
            {
                Remove=true;
                return;
            }
            setLocation(LocationX[LastArr],LocationY[LastArr],LocationZ[LastArr]);
            PosY=getY();
            PosX=getX();
            PosZ=getZ();
            LastArr++;
            while(Steps[LastArr-1]<=0)
                Steps[LastArr-1]++;
            MoveX  =  (double)(LocationX[LastArr]-getX())/(double)(Steps[LastArr-1]);
            MoveY  =  (double)(LocationY[LastArr]-getY())/(double)(Steps[LastArr-1]);
            MoveZ  =  (double)(LocationZ[LastArr]-getZ())/(double)(Steps[LastArr-1]);
            if(Turner)
                turnTo(LocationX[LastArr],LocationY[LastArr]);
            Steped =  0;
        }
        else
        {
            PosX+=MoveX;
            PosY+=MoveY;
            PosZ+=MoveZ;
            setLocation((int)PosX,(int)PosY,(int)PosZ);
            Steped++;
        }
    }
}
