import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Welt here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Welt extends WorldZoom
{
    public int MouseX=500;
    public int MouseY=350;
    public int ScrollSpeed=20;
    private Aimer Mouse = new Aimer();
    private int Points=0,ReloadTime=0,Armour=10,ShotSound=0;
    private Counter Counter = new Counter(),ammo=new Counter();
    private boolean Reload=false;
    private static GreenfootSound [] RiffleLoad = {new GreenfootSound("RifleLoad.wav"),new GreenfootSound("RifleLoad2.wav")},
    RiffleShot = {
            new GreenfootSound("RifleShot.wav"),
            new GreenfootSound("RifleShot.wav"),
            new GreenfootSound("RifleShot.wav"),
            new GreenfootSound("RifleShot.wav"),
            new GreenfootSound("RifleShot.wav"),
        },
    NoAmmo = {
            new GreenfootSound("NoAmmo.wav"),
            new GreenfootSound("NoAmmo.wav"),
            new GreenfootSound("NoAmmo.wav"),
            new GreenfootSound("NoAmmo.wav"),
            new GreenfootSound("NoAmmo.wav"),
        };
    private static GreenfootImage Landscape = new GreenfootImage("Landscape1.png"),
    Desk = new GreenfootImage("Desk.png");
    /**
     * Constructor for objects of class Welt.
     * 
     */
    public Welt()
    {
        super(2000,1000,800,550,100,50,1000,1); 
        newBackground(Desk);
        addObject(Mouse,213,22);
        setPaintOrder(Aimer.class,NoScrollObjects.class,Landscape.class,Actor.class);
        int A=15;
        int [][]a=
            {
                {  0,263,402,579,714,779,976,999, 1001,1193,1296,1764,1999},
                {407,407,494,520,351,243,147, 147, 147, 148, 101,  94,  95},
                {500,500,500,500,500,500,500, 500, 200, 200, 200, 200, 200},
                {0,0,0,0,0,0,0,1}
            };
        addObject(new MovingAimCreator(a[0],a[1],a[2],a[3],100),500,500);
        int [][]b=
            {
                {  0,263,402,579,775,818,1051,1188},
                {407,407,494,520,513,535, 540, 535},
                {500,500,500,500,600,500,400, 400,200,200,200},
                {0,0,0,1,0,0,0,0}
            };
        MovingAimCreator MAC = new MovingAimCreator(b[0],b[1],b[2],b[3],100);
        addObject(MAC,500,500);
        MAC.Time=50;
        Landscape L = new Landscape();
        addObject(L,getWidth()/2,getHeight()/2);
        L.setImage(Landscape);
        addObject(Counter,100,30);
        Counter.UpdateImage("Score: " + Points);
        addObject(ammo,695,30);
        ammo.UpdateImage("Ammo: " + Armour);
    }

    public void act()
    {
        MouseSettings();
        if(Reload)
        {
            ReloadTime--;
            if(ReloadTime%20==0)
                RiffleLoad[Greenfoot.getRandomNumber(2)].play();
            ammo.UpdateImage("reloading");
            if(ReloadTime<=0)
            {
                Armour=10;
                Reload=false;
            }
        }
        else
            ammo.UpdateImage("Ammo: " + Armour);
    }

    public void addPoints(int HowMany)
    {
        Points+=HowMany;
        Counter.UpdateImage("Score: " + Points);
    }

    private void MouseSettings()
    {
        ScrollWorld();
        Mouse.setLocation(MouseX,MouseY);
        Shoot();
        ChangeMouseImage(new GreenfootImage(1,1),0,0);
    }

    public void Shoot()
    {
        if(Greenfoot.mouseClicked(null))
        {
            MouseInfo M = Greenfoot.getMouseInfo();
            MouseX=M.getX();
            MouseY=M.getY();
            if(M.getButton()==3)
            {
                Reload=true;
                ReloadTime=(10-Armour)*20;
            }
            if(M.getButton()==1)
                if(!ClickedLandscape())
                {
                    if(!ClickedScoreboard())
                    {
                        ShotSound++;
                        if(ShotSound>=5)
                            ShotSound=0;
                        if(Armour>0 && !Reload)
                        {
                            List<Aims> A = getObjectsAt(MouseX,MouseY,Aims.class);
                            for(Aims a : A)
                            {
                                a.MouseClicked=true;
                            }
                            Armour--;
                            RiffleShot[ShotSound].play();
                        }
                        else
                        if(Armour==0 && !Reload)
                        {
                            NoAmmo[ShotSound].play();
                        }
                    }
                    else
                    {
                        List<Scoreboard> A = getObjectsAt(MouseX,MouseY,Scoreboard.class);
                        for(Scoreboard a : A)
                        {
                            int x = MouseX;
                            int y = MouseY;
                            GreenfootImage i = a.getImage();
                            x=x-(a.getX()-i.getWidth()/2);
                            y=y-(a.getY()-i.getHeight()/2);
                            if(i.getColorAt(x,y).getAlpha()>10)
                                a.Clicked();
                        }
                    }
            }
        }
    }

    public boolean ClickedLandscape()
    {
        List<Landscape> A = getObjectsAt(MouseX,MouseY,Landscape.class);
        for(Landscape a : A)
        {
            int x = MouseX;
            int y = MouseY;
            GreenfootImage i = a.getImage();
            x=x-(a.getScreenX()-i.getWidth()/2);
            y=y-(a.getScreenY()-i.getHeight()/2);
            if(i.getColorAt(x,y).getAlpha()>10)
                return true;
        }
        return false;
    }

    public boolean ClickedScoreboard()
    {
        List<Scoreboard> A = getObjectsAt(MouseX,MouseY,Scoreboard.class);
        for(Scoreboard a : A)
        {
            int x = MouseX;
            int y = MouseY;
            GreenfootImage i = a.getImage();
            x=x-(a.getX()-i.getWidth()/2);
            y=y-(a.getY()-i.getHeight()/2);
            if(i.getColorAt(x,y).getAlpha()>10)
                return true;
        }
        return false;
    }

    public void ScrollWorld()
    {
        if(Greenfoot.mouseMoved(null))
        {
            MouseInfo M = Greenfoot.getMouseInfo();
            MouseX=M.getX();
            MouseY=M.getY();
        }
        if(MouseX<ScrollSpeed)
            ShowWorld(getScreenLeft()-(ScrollSpeed-MouseX),getScreenUp());
        if(MouseX>getScreenWidth()-ScrollSpeed)
            ShowWorld(getScreenLeft()+(MouseX-(getScreenWidth()-ScrollSpeed)),getScreenUp());
        if(MouseY<ScrollSpeed)
            ShowWorld(getScreenLeft(),getScreenUp()-(ScrollSpeed-MouseY));
        if(MouseY>getScreenHeight()-ScrollSpeed)
            ShowWorld(getScreenLeft(),getScreenUp()+(MouseY-(getScreenHeight()-ScrollSpeed)));
    }

    public void Creator(int []X, int []Y, int []Z, int []Steps, int TimeSteps)
    {

    }
}
