import greenfoot.*;
import greenfoot.core.WorldHandler;
import javax.swing.*;
import java.awt.Cursor;
import java.awt.Point;
import java.awt.Toolkit;

public class WorldZoom  extends Scrollworld
{
    public int Deep;

    public WorldZoom(int Width, int Height,int ScreenWidth, int ScreenHeight,int ScreenLeft,int ScreenUp,int DeepSteps, int CellSize)
    {
        this(Width,Height,ScreenWidth,ScreenHeight,ScreenLeft,ScreenUp,DeepSteps,CellSize,true);
    }
    public WorldZoom(int Width, int Height,int ScreenWidth, int ScreenHeight,int ScreenLeft,int ScreenUp,int DeepSteps, int CellSize, boolean BackgroundMove)
    {
        super(Width,Height,ScreenWidth,ScreenHeight,ScreenLeft,ScreenUp,CellSize,BackgroundMove);
        Deep=DeepSteps;
    }

    public void addObject(ZoomObjects Z, int x, int y, int z)
    {
        super.addObject(Z,x,y);
        Z.setLocation(x,y,z);
    }

    public void addObject(ZoomObjects Z, int x, int y)
    {
        super.addObject(Z,x,y);
        Z.setLocation(x,y,0);
    }

    public int getDeep()
    {
        return Deep;
    }
    
    public void ChangeMouseImage(GreenfootImage image, int XClick, int yClick)
    {
        JPanel Panel = WorldHandler.getInstance().getWorldCanvas();
        Cursor Cursor;
        Toolkit Tk = Toolkit.getDefaultToolkit();
        Point CursorPoint= new Point(0,0);
        Cursor = Tk.createCustomCursor(image.getAwtImage(),CursorPoint,"Somehow");
        Panel.setCursor(Cursor);
    }
}
