import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ZoomObjects here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ZoomObjects extends ScrollObjects
{
    private int z=0;
    private GreenfootImage Image;
    private GreenfootImage NormalImage;
    private boolean boolImage;
    
    public GreenfootImage getImage()
    {
        return Image;
    }

    private GreenfootImage getNormalImage()
    {
        return NormalImage;
    }

    public void setImage(String i)
    {
        setImage(new GreenfootImage(i));
    }

    public void setImage(GreenfootImage i)
    {
        Image = i;
        NormalImage=new GreenfootImage(i);
        if(boolImage)
        {
            boolean b = false;
            double Z = (double)(getWorld().getDeep()-z+1)/(double)(getWorld().getDeep());
            int IW = (int)(Z*(double)(i.getWidth()));
            int IH = (int)(Z*(double)(i.getHeight()));
            if(IW<=0)
            {
                IW=1;
            }
            if(IH<=0)
            {
                IH=1;
            }
                i.scale(IW,IH);
        }
        else
            boolImage=true;
        super.setImage(i);
    }
    
    public void setLocation(int x, int y, int z)
    {
        if(z>getWorld().getDeep()-1)
        {
            z=getWorld().getDeep()-1;
        }
        if(z<0)
        {
            z=0;
        }
        setLocation(x,y);
        this.z=z;
        setImage(getNormalImage());
    }

    public WorldZoom getWorld()
    {
        return (WorldZoom)(super.getWorld());
    }

    public int getZ()
    {
        return z;
    }
}
